﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Mvc.Shared;
using MvcSampleApplication.Models;
using Syncfusion.Mvc.Grid;
using System.Collections;

namespace MVCEssentialGrid.Controllers
{
    public class EditingController : Controller
    {
        /// <summary>
        /// Used for rendering the grid initially.
        /// </summary>
        /// <returns>Veiw page, it displays the Grid</returns>
        public ActionResult ExternalForm(GridEditMode? GridMode)
        {
            ViewData["data"] = OrderRepository.GetAllRecords();
            ViewData["Mode"] = GridMode == null ? GridEditMode.Normal : (GridEditMode)GridMode;            
            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult ExternalForm(PagingParams args, GridEditMode? GridMode, int? OrderID)
        {
           
                IEnumerable data = OrderRepository.GetAllRecords();
                return data.GridJSONActions<EditableOrder>();
           
        }


        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult OrderSave(EditableOrder ord)
        {
            OrderRepository.Update(ord);

            var data = OrderRepository.GetAllRecords();

            return data.GridJSONActions<EditableOrder>();

        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult AddOrder(EditableOrder ord)
        {
            OrderRepository.Add(ord);

            var data = OrderRepository.GetAllRecords();

            return data.GridJSONActions<EditableOrder>();

        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult DeleteOrder(int OrderID)
        {

            OrderRepository.Delete(OrderID);

            var data = OrderRepository.GetAllRecords();

            return data.GridJSONActions<EditableOrder>();

        }

    }
}

    

