﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Mvc.Grid;
using Syncfusion.Mvc.Shared;
using MvcSampleApplication.Models;
using System.Collections;


namespace MvcSampleApplication.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        private int OrderID;
        /// <summary>
        /// Used for rendering the grid initially.
        /// </summary>
        /// <returns>Veiw page, it displays the Grid</returns>
        public ActionResult Index()
        {
            IEnumerable data = new NorthwindDataContext().Orders.Take(200).ToList();
            return View(data);
        }

        /// <summary>
        /// Paging/editing Request is mapped to this method. This method invokes the HtmlActionResult
        /// from the Grid. Required response is generated.
        /// </summary>
        /// <param name="args">Contains paging properties </param>
        /// <returns>
        /// HtmlActionResult which returns data displayed on the Grid
        /// </returns>
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index(PagingParams args)
        {
            IEnumerable data = new NorthwindDataContext().Orders.Take(200).ToList();
            return data.GridActions<Order>();

        }

      
    }
}
