﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
namespace MvcSampleApplication.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;

    public class EditableOrder
    {
        [Required(ErrorMessage="Order ID is required.")]
        public int OrderID
        {
            get;
            set;
        }

        [StringLength(5,ErrorMessage ="Customer ID must be 5 characters.")]
        public string CustomerID
        {
            get;
            set;
        }
        
        public int? EmployeeID
        {
            get;
            set;
        }

        
        public DateTime? OrderDate
        {
            get;
            set;
        }

      
        public string ShipName
        {
            get;
            set;
        }

        [StringLength(15, ErrorMessage = "ShipCity must be 15 characters.")]
        public string ShipCity
        {
            get;
            set;
        }

        public string ShipAddress
        {
            get;
            set;
        }

        public string ShipRegion
        {
            get;
            set;
        }

        public string ShipPostalCode
        {
            get;
            set;
        }

        [StringLength(15, ErrorMessage = "ShipName must be 15 characters.")]
        public string ShipCountry
        {
            get;
            set;
        }

        
        public decimal? Freight
        {
            get;
            set;
        }

        public bool Verified
        {
            get;
            set;
        }
       
    }
}