﻿/// <reference path="jquery/jQuery.intellisense.js" />
/// <reference name="MicrosoftAjax.js" />
Type.registerNamespace('Syncfusion.Library.Common');

Syncfusion.Library.Common.Editing = function () {

    Syncfusion.Library.Common.Editing.initializeBase(this);
    this._parent = null;        ///The Source element
    this._start = 0;
    this._currentRowIndex = -1;      /// Current tbody row
    this._previousData = {};
    this._currentData = {};
    this._isEdit = false;
    this.keyValue = null;
    this._isCancel = true;
    this._editMode = 'Normal';
    this._currentRow = null;
    this._editformContext = null;
    this._gridEditForm = null;
    this._formValidationOptions = null;
    this._gridID = null;
    //Bulk Editing
    this.currentCellValue = null;
    this.currentCellEditType = 0;
    this._data = {};
    this._currentDataItem = null;
    this.colObj = null;
    this._editTD = null;
    this._formatString = "";
    this._updatedRecords = new Array();
    this._addedRecords = new Array();
    this._deletedRecords = new Array();
    this.updateTlbr = false;
    this._blkEdtRequestType = null;
    this._defaultDataItem = null;
    this._insertedRowsCollection = new Array();
    this._istimeOutSet = true;
    this._timeSpan = null;
    this._isValid = true;
    this._timer = null;
}
Syncfusion.Library.Common.Editing.prototype = {
    get_Parent: function () {
        return this._parent;
    },
    set_Parent: function (value) {
        this._parent = value;
    },
    set_IsEdit: function (value) {
        this._isEdit = value;
    },
    get_IsEdit: function () {
        return this._isEdit;
    },
    set_Start: function (value) {
        this._start = value;
    },
    get_Start: function () {
        return this._start;
    },
    set_EditMode: function (value) {
        this._editMode = value;
    },
    get_EditMode: function () {
        return this._editMode;
    },
    get_TimeSpan: function () {
        return this._timeSpan;
    },
    set_TimeSpan: function (value) {
        this._timeSpan = value;
    },
    initialize: function () {
        ///Constructor

        Syncfusion.Library.Common.Editing.callBaseMethod(this, 'initialize');
        this.set_validation();

        ///Delegates for the Mouse Handler function
        //Add Handlers to the Mouse events on the Parent
        this._wireEvents();
    },
    dispose: function () {
        ///Destructor
        this._currentRow = null;
        this._editformContext = null;
        this._gridEditForm = null;
        this._formValidationOptions = null;
        this._gridID = null;
        Syncfusion.Library.Common.Editing.callBaseMethod(this, "dispose")
    },
    _wireEvents: function () {
        //Add Event handlers
        this.mDblClickHandler = Function.createDelegate(this, this._mDblClickHandler);
        this.mClickHandler = Function.createDelegate(this, this._mClickHandler);
        //        $addHandler(this._parent, 'click', Function.createDelegate(this, this._mClickHandler));
        $(this._parent).live('click', this.mClickHandler);
        if (this._editMode == "Dialog" || this._editMode == "DialogTemplate") {
            this.dlgClickHandler = Function.createDelegate(this, this._mClickHandler);
            this.dlgCloseHandler = Function.createDelegate(this, this._dCloseHandler);
            $($("#" + this._gridID + "_EditDialog")).live('click', this.dlgClickHandler);
            $($("#" + this._gridID + "_EditDialog")).live("dialogbeforeclose", this.dlgCloseHandler);
        }
        else if (this._editMode == "ExternalForm") {
            this.dlgClickHandler = Function.createDelegate(this, this._mClickHandler);
            $($("#" + this._gridID + "_ExternalForm")).live('click', this.dlgClickHandler);
        }
        else if (this._editMode == "AutoExcel" || this._editMode == "ManualExcel") {
            this.mouseDownHandler = Function.createDelegate(this, this._mouseDownHandler);
            $(document).bind('mousedown', this.mouseDownHandler);
            var proxy = this;
            var grid = $find(this._gridID);
            $.each(grid.get_VisibleColumns(), function (indx, val) {
                proxy.CreateEditingObject(val, val.cellEditType);
            });
            $("#" + this._gridID + "_bulkEditTemplate").appendTo("body");
        }
    },
    _unwireEvents: function () {
        //remove Event handlers
        //$removeHandler(this._parent, 'dblclick', this.mDblClickHandler);
        //$removeHandler(this._parent, 'click', this.mClickHandler);
        $(this._parent).die('click', this.mClickHandler);
    },
    _mouseDownHandler: function (e) {
        this._saveCell(e.target);
    },
    _saveCell: function (target) {
        if (this._editTD && !$.contains(this._editTD, target) && this._editTD != target && !$(target).closest('.ui-datepicker').length) {
            //validating the data      
            var errorMessages = null;
            if (this._editformContext != null)
                errorMessages = this._editformContext.validate('submit');
            if (!Sys.Mvc._validationUtil.arrayIsNullOrEmpty(errorMessages)) {
                this._isValid = false;
                return;
            }
            else {
                this._isValid = true;
                var grid = $find(this._gridID);
                var updatedData = this._findUpdatedCellData();
                var onCellSaveHandler = grid.get_events().getHandler("OnCellSave");
                var eventArgs = new Syncfusion.Mvc.Grid.BulkEditEventArgs(this.colObj, updatedData);
                if (onCellSaveHandler)
                    onCellSaveHandler(this, eventArgs);
                //enable save button
                var isUpdated = $("#" + grid.get_element().id + " td").hasClass("updatedCell");
                if (isUpdated)
                    grid.gridtoolbar.Enable_ToolbarItembyID(grid.get_element().id + "Save");
                if (updatedData != this.currentCellValue) {
                    //enable save button
                    if (isUpdated)
                        grid.gridtoolbar.Enable_ToolbarItembyID(grid.get_element().id + "Save");
                    $(this._editTD).addClass("updatedCell");
                    this._isEdit = true;
                    //  var isInsertedRow = $($($(this._editTD)).parent()).hasClass("InsertedRow");
                    if (this._blkEdtRequestType == "Edit") {
                        this._currentDataItem[this.currentColumnName] = updatedData;
                        //save the updated record in an array 
                        if ((this._updatedRecords.length == 0 || jQuery.inArray(this._currentDataItem, this._updatedRecords) == -1) && jQuery.inArray(this._currentDataItem, this._addedRecords) == -1)
                            Array.add(this._updatedRecords, this._currentDataItem);
                    }
                    else if (this._blkEdtRequestType == "AddNew") {
                        var _dfltDataItem = jQuery.extend(true, {}, this._defaultDataItem);
                        var index = jQuery.inArray($(this._editTD).parent()[0], this._insertedRowsCollection);
                        this._addedRecords[index][this.currentColumnName] = updatedData;
                    }
                    if (!this.updateTlbr)
                        this._updateToolbar(grid);

                }
                if (this._formatString != "" && this.currentCellEditType != 5)
                    updatedData = grid.jsonModeMgr._formatting(this._formatString, updatedData, this.currentColumnName);
                if (this.colObj.TemplateColumn) {
                    var div = document.createElement('div');
                    $(div).append("#" + this._gridID + "_" + this.colObj.Member + "_Template", this._currentDataItem);
                    $(this._editTD).html(div.children[0].innerHTML).removeClass("BulkEditCell");
                }
                else {
                    $(this._editTD).removeClass("BulkEditCell");
                    if (this.colObj.type == "Boolean") {
                        if (updatedData)
                            $(this._editTD).html("<input type='checkbox' name='" + this.colObj.Member + "' disabled='disabled' checked='checked'/>");
                        else
                            $(this._editTD).html("<input type='checkbox' name='" + this.colObj.Member + "' disabled='disabled'/>");
                    }
                    else
                        $(this._editTD).html(updatedData.toString());
                }
                if ($("#" + grid.get_element().id + " td").hasClass("updatedCell"))//setting the timeout function to call the save function automatically if edit mode is set to manual
                    this._callTimeOut(grid);
                this._editTD = null;
                $("#" + this._gridID)[0].focus();
            }
        }
    },
    _callTimeOut: function (grid) {
        if (this._editMode == "AutoExcel" && this._istimeOutSet) {
            this._timer = window.setTimeout(function () {
                if (!$("#" + grid.get_element().id + " td").hasClass("BulkEditCell")) {
                    grid.sendSaveRequest();
                    this._istimeOutSet = false;
                }
                else {
                    clearTimeout(this._timer);
                    this._istimeOutSet = true;
                }
            }, this._timeSpan);
        }
    },
    _findUpdatedCellData: function () {
        var updatedData = "";
        switch (this.currentCellEditType) {
            case 0:
            case 6:
                updatedData = $("#" + this._gridID + " #" + this.currentColumnName).val();
                break;
            case 1: //need to be updated
                if ($("#" + this._gridID + " #" + this.currentColumnName).is(':checked'))
                    updatedData = true;
                else
                    updatedData = false;
                break;
            case 2:
            case 3:
            case 5:
                var _element = $(this._editTD).find("#" + this.currentColumnName)[0];
                if (this.currentCellEditType == 2)
                    updatedData = $("#" + this._gridID + " #" + this.currentColumnName + "_numerictextbox").val();
                else if (this.currentCellEditType == 3)
                    updatedData = $("#" + this._gridID + " #" + this.currentColumnName + "_percenttextbox").val();
                updatedData = parseFloat(updatedData);
                if (this.currentCellEditType == 5)
                    updatedData = $("#" + this._gridID + " #" + this.currentColumnName).val();
                var col = $("#" + this._gridID + "_bulkEditTemplate #" + this.currentColumnName + "_bulkEdit");
                var div = document.createElement("div");
                $(div).appendTo(col);
                $(div).replaceWith(_element);

                break;
            case 4:
                updatedData = $("#" + this._gridID + " #" + this.currentColumnName + "_maskedithiddenField").val();
                updatedData = parseFloat(updatedData);
                break;
            default:
                break;
        }
        return updatedData;
    },
    _mClickHandler: function (e) {
        debugger;
        var gridID = this._gridID;
        var currentForm = $(e.target).parents('form');
        var grid = $find(gridID.toString());
        if ($(e.target).closest("form").length > 0 && $(e.target).closest("form")[0].id == gridID + "EditForm" && $(e.target).attr("type") == "button" && $(e.target).attr("value") == "Save") {
            this._isCancel = false; //for dialog editing
            this._editformValidate(e, grid);
        }
        else if ($(e.target).closest("form").length > 0 && $(e.target).closest("form")[0].id == gridID + "EditForm" && $(e.target).attr("type") == "button" && $(e.target).attr("value") == "Cancel") {
            if (this._editMode == "Dialog" || this._editMode == "DopenalogTemplate")
                $("#" + gridID + "_EditDialog").dialog("close");
            else if (this._editMode == "ExternalForm")
                $("#" + gridID + "_ExternalForm").hide();
            grid.sendCancelRequest();
        }
        else if (grid != null && grid.get_AllowEditing() == true && this._isEdit && $(e.target).closest('form').length > 0 && $(e.target).closest('form').attr('id') != gridID + "EditForm" && !(this._editMode == "AutoExcel" || this._editMode == "ManualExcel")) {
            if (this._currentRowIndex != $(e.target).parents('tr:first')[0].rowIndex) {
                this._isCancel = false; //for dialog editing
                this._editformValidate(e, grid);
            }
        }
        else if (currentForm != null && currentForm.length > 0 && !(this._editMode == "Dialog" || this._editMode == "ExternalForm" || this._editMode == "DialogTemplate" || this._editMode == "AutoExcel" || this._editMode == "ManualExcel")) {
            if (grid != null && grid.get_AllowEditing() && this._isEdit && this._currentRowIndex != ($(e.target).parents('tr:first').length > 0 ? currentForm.parents('tr:first')[0].rowIndex : -1) && $(e.target)[0].tagName != "INPUT") {
                if (!($(e.target).closest('form').length > 0 && $(e.target).closest('form').attr('id') != gridID + "EditForm"))
                    this._editformValidate(e, grid);
            }
        }
        else if ($(e.target).hasClass("RowCell") && e.target.tagName == "TD" && (this._editMode == "AutoExcel" || this._editMode == "ManualExcel")) {
            this._renderEditCell(e.target, grid);
        }
    },
    _updateToolbar: function (grid) {
        var $tools = grid.get_EnableToolbar() ? grid.gridtoolbar._toolbarItems : null;
        if ($tools != null) {
            $.each($tools, function () {
                if (this.id == grid.get_element().id + "Save" || this.id == grid.get_element().id + "Cancel")
                    grid.gridtoolbar.Enable_ToolbarItembyID(this.id);
            });
        }
        this.updateTlbr = true;
    },

    //deleting the record in bulk edit mode
    _deleteRecord: function (rowIndex) {
        var tr = $("#" + this._gridID + "_Table tbody").find('tr')[rowIndex];
        var recordIndex = this._rowIndex(tr);
        var grid = $find(this._gridID);
        var dataItem = jQuery.extend(true, {}, this._data[recordIndex - this._addedRecords.length]);
        $(tr).css("display", "none");
        $($(tr).find('td')).addClass("updatedCell");
        this._updateToolbar(grid);
        this._isEdit = true;
        Array.add(this._deletedRecords, dataItem);
        this._callTimeOut(grid);
    },

    //rendering the edit cell in bulk edit mode
    _renderEditCell: function (target, grid) {
        if (!($("#" + this._gridID + " tbody td").hasClass("BulkEditCell")) && target != null) {
            var cellIndex = $(target)[0].cellIndex;
            var currentColHeaderText = this.getCurrentColumnHeaderText(cellIndex, grid);
            var isEditable = true;
            var proxy = this;
            $.each(grid.get_VisibleColumns(), function (indx, val) {
                if (val.HeaderText == currentColHeaderText) {
                    proxy.currentColumnName = val.Member;
                    isEditable = val.AllowEditing;
                    proxy.currentCellEditType = val.cellEditType;
                    proxy._formatString = val.FormatText;
                    proxy.colObj = val;
                }
            });
            var _priKeyIndex = jQuery.inArray(proxy.currentColumnName, grid.get_PrimaryKeys());
            if (_priKeyIndex != -1)
                isEditable = false;
            var isInsertedRow = $(target.parentNode).hasClass("InsertedRow");
            if (isInsertedRow)
                isEditable = true;
            if (isEditable) {
                this._findCurrentDataItem(target);
                if (isInsertedRow) {
                    var index = jQuery.inArray($(target.parentNode)[0], this._insertedRowsCollection);
                    this.currentCellValue = this._addedRecords[index][this.currentColumnName];
                }
                else
                    this.currentCellValue = this._currentDataItem[this.currentColumnName];
                if (isInsertedRow) {
                    this._blkEdtRequestType = "AddNew";
                }
                else
                    this._blkEdtRequestType = "Edit";
                this._renderBulkEditObject(this.currentCellEditType, target, this.currentColumnName);
                this._setFormContext();
                var onCellEditHandler = grid.get_events().getHandler("OnCellEdit");
                var eventArgs = new Syncfusion.Mvc.Grid.BulkEditEventArgs(this.colObj, this.currentCellValue);
                if (onCellEditHandler)
                    onCellEditHandler(this, eventArgs);
            }
        }
    },
    getCurrentColumnHeaderText: function (cellIndex, grid) {
        return $($($("#" + this._gridID + " .HeaderBar")[grid._headerRowIndex]).find('th')[cellIndex]).find(".HeaderCellDiv").html();
    },
    _setFormContext: function () {
        if (this._formValidationOptions != null) {
            var form = $("#" + this._gridID + "EditForm");
            var formValdOpt = this.checkValidationOption(form);
            if (Sys.Mvc.FormContext._parseJsonOptions == undefined)
                this._editformContext = Sys.Mvc.FormContext.$12(formValdOpt);
            else
                this._editformContext = Sys.Mvc.FormContext._parseJsonOptions(formValdOpt);
        }
        this.authenticateFormContext();
    },
    _renderBulkEditObject: function (_cellEditType, target, colName) {
        //for numeric and percent textbox based on the target width, the width is calculated. So "BulkEditCell" class
        //will be added after the width calculation
        if (!(_cellEditType == 2 || _cellEditType == 3))
            $(target).addClass("BulkEditCell");
        var form = document.createElement('form');
        $(form).attr('id', this._gridID + "EditForm");
        if (_cellEditType == 5) {
            this.currentCellValue = $(target)[0].innerHTML;
            var dp = $("#" + this._gridID + "_bulkEditTemplate #" + colName);
            $(form).html($("#" + colName + "_bulkEdit").html());
            $(target).html("");
            $(target).append(form);
            $(dp).datepicker('setDate', $.datepicker.parseDate(dp.datepicker("option", "dateFormat").toLowerCase(), this.currentCellValue));
            $("#" + this._gridID + " #" + colName).replaceWith(dp);
            $("#" + this._gridID + " #" + colName).focus();
        }
        else if (_cellEditType == 2 || _cellEditType == 3) {
            var div = document.createElement("div");
            $(form).html(div);
            $(target).html("");
            $(target).append(form);
            $(div).replaceWith($("#" + colName + "_bulkEdit #" + colName));
            var width = $(target).width() * (90 / 100);
            $(target).addClass("BulkEditCell");
            $("#" + this._gridID + " #" + colName + " .GridEditors").css("width", "auto");
            var input;
            if (_cellEditType == 2)
                input = $("#" + this._gridID + " #" + colName + "_numerictextbox");
            else
                input = $("#" + this._gridID + " #" + colName + "_percenttextbox");
            $(input).css("width", width + "px");
            $(input).val(this.currentCellValue == null ? 0 : this.currentCellValue);
            $(input).focus();
            $(input)[0].focus();
        }
        else if (_cellEditType == 1) {
            $(form).html($("#" + colName + "_bulkEdit").html());
            $(target).html("");
            $(target).append(form);
            if (this.currentCellValue == true)
                $($(target).find('input[type="checkbox"]')[0]).attr('checked', 'checked').focus();
            else
                $($(target).find('input[type="checkbox"]')[0]).removeAttr('checked', 'checked').focus();
        }
        else if (_cellEditType == 6) {
            $(form).html($("#" + colName + "_bulkEdit").html());
            $(target).html("");
            $(target).append(form);
            var grid = $find(this._gridID);
            var optionsObj = eval("grid.jsonModeMgr._jsonDataAndOption." + colName + "_Options");
            $("#" + colName).html($($("#" + this._gridID + "_bulkEditTemplate").tmpl(optionsObj).find('option')));
            var editElement = $("#" + this._gridID + " #" + colName);
            $(editElement).val(this.currentCellValue == null ? "" : this.currentCellValue);
            $(editElement).val(this.currentCellValue).focus();
        }
        else {
            $(form).html($("#" + colName + "_bulkEdit").html());
            $(target).html("");
            $(target).append(form);
            var editElement = $("#" + this._gridID + " #" + colName);
            $(editElement).val(this.currentCellValue == null ? "" : this.currentCellValue);
            $(editElement).focus();
        }
        if (this._editTD == null) {
            this._editTD = target;
            this.currentColumnName = colName;
            this.currentCellEditType = _cellEditType;
        }

    },
    _findCurrentDataItem: function (target) {
        this._editTD = target;
        var tr = $(this._editTD).parent();
        var rowIndex = this._rowIndex(tr);
        if (!$(target.parentNode).hasClass("InsertedRow"))
            this._currentDataItem = this._data[rowIndex - this._addedRecords.length];
    },
    _rowIndex: function (tr) {
        return $(tr).parent().find('tr:not(:has(*<.GroupCaption))').index(tr);
    },
    _mDblClickHandler: function (e) {
        if (!(this._editMode == "AutoExcel" || this._editMode == "ManualExcel")) {
            var gridID = $($(this.get_Parent()).parents('.GridContent:first')).parent()[0].id;
            var targetRow = $(e.target).parents('tr:first')[0];
            if (e.target.parentNode != null && $(e.target).parents('tr[class=' + gridID + 'ChildRow]').length > 0)
                return;

            if ($(targetRow).find('.EmptyCell').length > 0 || !($(targetRow).find('.RowCell').length > 0)) {
                return;
            }
            var grid = $find(gridID.toString());
            if (grid != null && grid.get_AllowEditing() == true) {
                this.StartEdit(e, grid);
            }
        }
    },
    _dCloseHandler: function (event) {
        if (this._isCancel) {
            var gridID = this._gridID;
            var grid = $find(gridID);
            grid.sendCancelRequest();
        }
    },
    _editformValidate: function (e, grid) {
        //  grid.sendSaveRequest();
        var errorMessages = null;
        if (this._editformContext != null)
            errorMessages = this._editformContext.validate('submit');
        else if (this.mvc3EditingContext)
            errorMessages = this.mvc3EditingContext.form();
        if ((!errorMessages || !this.arrayIsNullOrEmpty(errorMessages)) && (grid._editMode.indexOf("Excel") == -1)) {
            if (e != undefined && e != null && e.preventDefault) e.preventDefault();
        }
        else {
            var handler = null;
            if (e != null && e.target != null && $(e.target).closest('form').length > 0 && $(e.target).closest('form').attr('id') != grid.get_element().id + "EditForm") {
                handler = this.get_events().getHandler("endEdit");
                eventArgs = new Syncfusion.Library.Common.Editing.EventArgs(null, null, false, this._currentRow, null);
            }
            if (handler) {
                handler(this, eventArgs);
            } else {
                grid.sendSaveRequest();
            }
        }

        this._isCancel = true;
    },
    add_BeginEdit: function (handler) {
        this.get_events().addHandler("beginEdit", handler);
    },
    remove_BeginEdit: function (handler) {
        this.get_events().removeHandler("beginEdit", handler);
    },

    add_EndEdit: function (handler) {
        this.get_events().addHandler("endEdit", handler);
    },
    remove_EndEdit: function (handler) {
        this.get_events().removeHandler("endEdit", handler);
    },
    set_validation: function () {
        Sys.Application.remove_load(arguments.callee);
        this._gridID = $(this._parent).parents('div:eq(1)')[0].id;
        var allFormOptions = window.mvcClientValidationMetadata;
        if (allFormOptions) {
            for (var i = 0; i < allFormOptions.length; i++) {
                var thisFormOptions = allFormOptions[i];
                if (thisFormOptions.FormId == this._gridID + "EditForm") {
                    Array.remove(allFormOptions, thisFormOptions);
                    this._formValidationOptions = thisFormOptions;
                }
            }
        }
        this._gridEditForm = $("#" + this._gridID + "EditForm");
        if (!(this._editMode == "AutoExcel" || this._editMode == "ManualExcel"))
            $("#" + this._gridID + "EditForm").remove();
    },
    StartEdit: function (e, grid) {
        var handler = null;
        var eventArgs = null;
        if ($(e.target).parents('tr:first').find('td').hasClass('GroupCaption') && $(e.target).parents('tr').hasClass(grid.get_element().id + 'ChildRow')) {
            return;
        }
        if (this._isEdit == false) {

            handler = this.get_events().getHandler("beginEdit");
            this._currentRowIndex = $(e.target).parents('tr:first')[0].rowIndex;
            this._currentRow = $(e.target).parents('tr:first')[0];

            var proxy = this;
            var primaryKeyValues = new Array();
            $.each(grid._MvcTable.get_primaryKeys(), function (i, value) {

                var colIndex = grid._MvcTable.get_columnIndexByMember(value)
                proxy.keyValue = $($(proxy._currentRow).find("td")[proxy.get_Start() + colIndex]).html();
                Array.add(primaryKeyValues, proxy.keyValue);
            });

            var vColumns = grid.get_VisibleColumns();
            for (var i = 0; i < vColumns.length; i++) {
                this._currentData[vColumns[i].Name] = $($($(e.target).parents('tr:first')[0]).find("td")[this.get_Start() + i]).html();
            }

            eventArgs = new Syncfusion.Library.Common.Editing.EventArgs(this._previousData, this._currentData, false, this._currentRow, primaryKeyValues);
            if (handler) {
                handler(this, eventArgs);
            }
        }
        else {

            this._editformValidate(e, grid);
        }

    },



    RefreshEditForm: function (columns) {
        var form = $get(this._gridID + "EditForm");
        if (form == null)
            return;
        if ($.validator != null) {
            $.validator.unobtrusive.parse("#" + this._gridID + "EditForm");
            this.mvc3EditingContext = $(form).validate();
        }
        var proxy = this;
        $.each(columns, function () {
            if (this.type == 'DateTime') {
                if (this.AllowEditing) {
                    debugger;
                    var dp = null;
                    if (proxy._editMode == "Dialog" || proxy._editMode == "ExternalForm" || proxy._editMode == "DialogTemplate") {

                        dp = $("#" + proxy._gridID).find('#' + this.Name);
                    }
                    else {
                        dp = $("#" + proxy._gridID).find('#' + this.Name)[1];
                    }
                    try {
                        $(dp).datepicker('setDate', $.datepicker.parseDate($(dp).datepicker("option", "dateFormat").toLowerCase(), $(form).find('#' + this.Name).val()));
                    }
                    catch (E) {
                        $(dp).val($(form).find('#' + this.Name).val());
                    }
                    $(form).find('#' + this.Name).replaceWith(dp);
                    $('#' + this.Name).show();
                }
            }
            if (proxy._editMode != "InlineTemplateForm" && proxy._editMode != "DialogTemplate")
                proxy.CreateEditingObject(this, this.cellEditType);

        });
        $.each(form, function () {
            if ($(this)[0].tagName != 'FIELDSET') {
                $(this).parent().append($(proxy._gridEditForm).find('span[id^=' + $(this).attr('name') + ']').clone());
            }
        });

        if (this._editMode == "Normal") {
            $.each(form, function () {
                if (this.tagName == "INPUT") {
                    var inputWidth = $($(this).parents('td[class*=RowCell]')[0]).width() - 15;
                    $(this).width(inputWidth > 0 ? ($(this).width() > inputWidth ? inputWidth : $(this).width()) : 1);
                    if ($(this).attr('id').toString().indexOf("maskedittextbox") != -1) {
                        var maskEditParent = $(this).parent('div.maskeditInputTextBase:first');
                        if (maskEditParent != null && maskEditParent.length > 0) {
                            $(maskEditParent[0]).css('width', $(this).css('width'));
                        }
                    }
                }
            });
        }
        if (this._formValidationOptions != null) {
            var cloneValidationOptions = this.checkValidationOption(form);

            if (Sys.Mvc.FormContext._parseJsonOptions == undefined)
                this._editformContext = Sys.Mvc.FormContext.$12(cloneValidationOptions);
            else
                this._editformContext = Sys.Mvc.FormContext._parseJsonOptions(cloneValidationOptions);
        }
        this.authenticateFormContext();
        this._isEdit = true;
    },
    checkValidationOption: function (form) {
        var cloneValidationOptions = $.extend(true, {}, this._formValidationOptions);
        var hiddenColumns = new Array();
        var rCollection = new Array(); //fields to be removed
        var en = new Array();
        $.each(cloneValidationOptions.Fields, function (index, val) {
            if ($(form).find('[name = ' + val.FieldName + ']').length <= 0)
                hiddenColumns.push(val.FieldName);
        });
        $.each(hiddenColumns, function (hiddenColumnIndex, value) {
            en = $.Enumerable.From(cloneValidationOptions.Fields).Where(function (p) {
                return eval('p.FieldName == value');
            }).ToArray();
            rCollection.push(en[0]);
        });
        $.each(rCollection, function (index, val) {
            Array.remove(cloneValidationOptions.Fields, val);
        });
        return cloneValidationOptions;
    },
    authenticateFormContext: function () {
        if (this._editformContext != null) {
            $.each(this._editformContext.fields, function (index, val) {
                if (val.elements.length == 0) {

                } else {
                    for (i = 0; i < val.elements.length; i++) {
                        if (val.elements[i] == null)
                            continue;
                        if (val.elements[i].name == undefined || val.elements[i].name == null) {
                            Array.remove(val.elements, val.elements[i]);
                        }
                    }
                }
            });
        }
    },
    CreateEditForm: function (grid, data, requestType) {
        var table = document.createElement('table');
        var tbody = document.createElement('tbody');
        var tr = document.createElement('tr');
        var rowHeader = document.createElement('td');
        $(rowHeader).addClass('RowHeader');
        tr.appendChild(rowHeader);
        var editCell = document.createElement('td');
        var colspanCount = $(this.get_Parent()).find("colgroup col").length - 1;

        $(editCell).addClass('EditInlineForm').addClass('RowCell').attr('colspan', colspanCount);

        var form = this.CreateForm(grid, data, requestType);
        editCell.appendChild(form);
        tr.appendChild(editCell);

        tbody.appendChild(tr)

        table.appendChild(tbody);



        return table;
    },
    CreateForm: function (grid, data, requestType) {
        var form = document.createElement('form');

        $(form).attr('id', this._gridID + "EditForm").attr('method', 'post').addClass('EditForm');
        if (requestType == "BeginEdit")
            $(form).attr('action', grid._gridSaveMapper);
        else
            $(form).attr('action', grid._gridAddNewMapper);
        $(form).html(data);

        var submitButton = document.createElement('input');
        $(submitButton).attr('type', 'button').attr('value', 'Save');
        var cancelButton = document.createElement('input');
        $(cancelButton).attr('type', 'button').attr('value', 'Cancel');

        var para = document.createElement('p');

        $(submitButton).appendTo(para);
        $(cancelButton).appendTo(para);

        $(para).appendTo($(form).find('fieldset'));
        return form;
    },
    handleEvent: function (funcname, obj, e) {
        var code;
        if (e.Event.keyCode) code = e.Event.keyCode; // ie and mozilla/gecko
        else if (e.Event.which) code = e.Event.which; // ns4 and opera
        else code = e.Event.charCode;
        var gridID = $($(this.get_Parent()).parents('.GridContent')).parent()[0].id;

        var grid = $find(gridID.toString());
        if (funcname == 'moveTo') {
            if (grid.keyConfigMgr.checkKey("SaveRequest", code, e.Event)) {
                //                e.Event.preventDefault();
                //                e.Event.cancelBubble;

                if (grid._saveOnEnter == false)
                    return;

                if (this._isEdit) {
                    this._editformValidate(e, grid);
                }

            }
            else if (grid.keyConfigMgr.checkKey("CancelRequest", code, e.Event)) {
                if (grid._closeOnEscape == false)
                    return;
                if (this._isEdit) {
                    grid.sendCancelRequest();
                }
            }

        }
    },

    CreateEditingObject: function (column, cellEditType) {
        var control = null;
        var controlString = "";
        var params = null;

        var gridID = $($(this.get_Parent()).parents('.GridContent')).parent()[0].id;
        var grid = $find(gridID.toString());
        var events = null;
        var obj = $find(column.Name);
        if (obj != null) {
            obj.dispose();
        }
        if (column.AllowEditing == true) {
            switch (cellEditType) {
                case 2:
                case 3:
                    if (cellEditType == 2) {
                        control = Syncfusion.Mvc.Shared.NumericTextBox;
                        controlString = "numerictextbox";
                        params = column.numericEditParams;
                    } else {
                        control = Syncfusion.Mvc.Shared.PercentTextBox;
                        controlString = "percenttextbox";
                        params = column.percentEditParams;
                    }
                    if (this.get_EditMode() == "Dialog" || this.get_EditMode() == "DialogTemplate")
                        $("#" + grid.get_element().id + "_EditDialog").find('input[id=' + column.Name + ']').attr('id', column.Name + "_" + controlString);
                    else if (this.get_EditMode() == "ExternalForm")
                        $("#" + grid.get_element().id + "_ExternalForm").find('input[id=' + column.Name + ']').attr('id', column.Name + "_" + controlString);
                    else
                        $(grid.get_element()).find('input[id=' + column.Name + ']').attr('id', column.Name + "_" + controlString);
                    events = { ClientSideFocusIn: params.ClientSideFocusIn,
                        ClientSideFocusOut: params.ClientSideFocusOut,
                        ClientSideMouseOver: params.ClientSideMouseOver,
                        ClientSideMouseOut: params.ClientSideMouseOut,
                        ClientSideValueChange: params.ClientSideValueChange,
                        ResetMinValue: cellEditType == 2 ? params.ResetMinValue : null,
                        ResetMaxValue: cellEditType == 2 ? params.ResetMaxValue : null
                    };
                    var div = document.createElement("div");
                    $(div).attr('id', column.Name);

                    if ($("#" + column.Name + "_" + controlString) == null || $("#" + column.Name + "_" + controlString).length == 0)
                        return;

                    $($("#" + column.Name + "_" + controlString)).wrap(div);

                    var valueofEditor = $("#" + column.Name + "_" + controlString).val();
                    valueofEditor = valueofEditor == null || valueofEditor.toString().replace(/^\s*/, "").replace(/\s*$/, "") == "" ? 0 : valueofEditor;
                    $("#" + column.Name + "_" + controlString).val(valueofEditor);
                    var _numericObj = $create(control,
                {
                    id: column.Name,
                    minValue: params.MinValue,
                    maxValue: params.MaxValue,
                    incrementStep: params.IncrementStep,
                    showSpinButton: params.ShowSpinButton,
                    waterMarkText: params.WaterMarkText,
                    decimals: params.Decimal,
                    error: params.Error,
                    value: valueofEditor,
                    skin: grid.get_Skin().toString().substring(grid.get_Skin().toString().lastIndexOf('-') + 1),
                    strictMode: params.strictMode,
                    isInitialRendered: false,
                    eventColl: events
                },
                null,
                null,
                div);
                    $("#" + column.Name).find("." + _numericObj.get_skin()).addClass('GridEditors');
                    break;
                case 4:
                    params = column.maskEditParams;
                    controlString = "maskedittextbox";
                    $(grid.get_element()).find("#" + column.Name + ":input").attr('id', column.Name + "_" + controlString);
                    var skinName = grid.get_Skin().toString().substring(grid.get_Skin().toString().lastIndexOf('-') + 1);
                    var div = document.createElement("div");
                    $(div).attr('id', column.Name).addClass("maskeditInputTextBase");
                    $($("#" + column.Name + "_" + controlString)).addClass(skinName + " maskeditInput").addClass("GridEditors").wrap(div);
                    events = { ClientSideFocusIn: params.ClientSideFocusIn,
                        ClientSideFocusOut: params.ClientSideFocusOut,
                        ClientSideMouseOver: params.ClientSideMouseOver,
                        ClientSideMouseOut: params.ClientSideMouseOut,
                        ClientSideValueChange: params.ClientSideValueChange
                    };
                    var _numericObj = $create(Syncfusion.Mvc.Shared.MaskEditTextBox,
                {
                    ID: column.Name,
                    Mask: params.Mask,
                    BindingMode: params.BindingMode,
                    WaterMarkText: params.WaterMarkText,
                    Error: params.Error,
                    Value: $("#" + column.Name + "_" + controlString).val(),
                    skin: skinName,
                    isInitialRendered: false,
                    eventColl: events
                },
                null,
                null,
                div);
                    break;
                default: break;
            }


        }

    },
    arrayIsNullOrEmpty: function (array) {
        return (!array || !array.length)
    }
}

Syncfusion.Library.Common.Editing.descriptor = {
    properties: [
                    { 'name': 'Element', 'type': 'Object' }
                ],
    events: [
                    { 'name': 'beginEdit' },
                    { 'name': 'endEdit' }
                 ]

}

Syncfusion.Library.Common.Editing.inheritsFrom(Sys.Component);

Syncfusion.Library.Common.Editing.registerClass('Syncfusion.Library.Common.Editing', Sys.Component);







