Type.registerNamespace("Syncfusion.Mvc.Grid.JSONMode");
Syncfusion.Mvc.Grid.JSONMode = function () {
    Syncfusion.Mvc.Grid.JSONMode.initializeBase(this);
    this._grid = null;
    this._groupingColumnIndex = 0;
    this._currentJsonData = null;
}
Syncfusion.Mvc.Grid.JSONMode.prototype = {
    initialize: function () {
        Syncfusion.Mvc.Grid.JSONMode.callBaseMethod(this, "initialize");
        this.add_initialTemplate();
        this.add_initialFilterChoiceTemplate();
        this.add_initialEditingTemplate();
    },
    dispose: function () {
        Syncfusion.Mvc.Grid.JSONMode.callBaseMethod(this, "dispose");
        this._grid = null;
    },
    get_gridId: function () {
        return this._gridId;
    },

    set_gridId: function (value) {
        this._gridId = value;
    },
    get_grid: function () {
        if (this._grid == null)
            this._grid = $find(this.get_gridId());
        return this._grid;
    },
    get_dataSource: function () {
        return this._currentJsonData;
    },
    set_dataSource: function (value) {
        this._currentJsonData = value;
        this.clientSideRefresh();
    },
    add_initialTemplate: function () {
        var context = this.get_grid();
        var JsonTemplate = $("#" + context.get_element().id + "_JSONTemplate");
        if (JsonTemplate != null && JsonTemplate.length > 0) {
            $(JsonTemplate.parentNode).remove();
        }
        var TBODY = $("<tbody></tbody>");
        var trTemplate = $("<tr></tr>");
        $(TBODY).attr('id', context.get_element().id + "_JSONTemplate").css('display', 'none');
        var td = $("<td></td>");
        $(td).addClass('RowHeader');
        $(td).html("<div>&nbsp;</div>");
        $(trTemplate).append(td);
        $.each(context.get_GroupedColumns(), function (index, val) {
            var tdIndent = $("<td>&nbsp;</td>");
            $(tdIndent).addClass("IndentCell");
            $(trTemplate).append(tdIndent);
        });
        if (this.get_grid().get_childGrid() != null && this.get_grid().get_childGrid() != "") {
            var tdMaster = $("<td></td>");
            $(tdMaster).addClass("MasterCellCollapse").html("<div>&nbsp;</div>").appendTo(trTemplate);
        }
        $.each(context.get_VisibleColumns(), function (index, val) {
            var tdCell = $("<td></td>");
            if (val.FormatText != "" && !val.TemplateColumn) {
                val.FormatText = val.FormatText.replace(/\"/g, "%280");
                if (val.Member == "")
                    $(tdCell).addClass("RowCell").html("{{html $item.format(\"" + val.FormatText + "\", \"" + val.Member + "\",\"" + val.Member + "\")}}");
                else
                    $(tdCell).addClass("RowCell").html("{{html $item.format(\"" + val.FormatText + "\", " + val.Member + ",\"" + val.Member + "\")}}");
            }
            else {
                if (val.type == 'DateTime' && !val.TemplateColumn)
                    $(tdCell).addClass("RowCell").html("{{html $item.format(\"{0:dd/MM/yyyy}\", " + val.Member + ",\"" + val.Member + "\")}}");
                else if (val.type == 'Boolean' && !val.TemplateColumn)
                    $(tdCell).addClass("RowCell").addClass("BoolRowCell").html("{{if " + val.Member + " == false}}<input type='checkbox' disabled='disabled' name='" + val.Member + "'></input> {{else}}<input type='checkbox' disabled='disabled' name='" + val.Member + "' checked='checked'></input>{{/if}}");
                else if (val.TemplateColumn) {
                    $(tdCell).addClass("RowCell").html("{{html $item.ColumnTemplate(\"" + val.Member + "\")}}");
                    $("body").append($("#" + "Grid1_" + val.Member + "_Template"));
                }
                else
                    $(tdCell).addClass("RowCell").html("${" + val.Member + "}");
            }
            $(trTemplate).append(tdCell);
        });
        $(TBODY).append(trTemplate);
        $("body").append(TBODY);
    },
    add_initialEditingTemplate: function () {
        if (this.get_grid().get_AllowEditing()) {
            var context = this.get_grid();
            var parentDivElement = $("<div></div>");
            var select = $("<select></select>");
            $(parentDivElement).attr('id', context.get_element().id + "_EditingOptionsJSONTemplate");
            $(select).css('display', 'none').append("<option value=\"${Value}\">${Text}</option>").appendTo(parentDivElement);
            $("body").append(parentDivElement);
            if (this.get_grid()._editMode == "Normal") {
                $("#" + context.get_element().id + "_EditingJSONTemplate").remove();
                var DivElement = $("<div></div>");
                var Table = $("<table></table>");
                var TBODY = $("<tbody></tbody>");
                $(TBODY).appendTo(Table);
                var trTemplate = $("<tr></tr>");
                $(DivElement).append(Table).attr('id', context.get_element().id + "_EditingJSONTemplate").css('display', 'none').appendTo('body');
                var td = $("<td></td>");
                $(td).addClass('RowHeader');
                $(td).html("<div>&nbsp;</div>");
                $(trTemplate).append(td);
                $.each(context.get_GroupedColumns(), function (index, val) {
                    var tdIndent = $("<td>&nbsp;</td>");
                    $(tdIndent).addClass("IndentCell");
                    $(trTemplate).append(tdIndent);
                });

                if (this.get_grid().get_childGrid() != "" && this.get_grid().get_childGrid() != null) {
                    var tdMaster = $("<td>&nbsp;</td>");
                    $(tdMaster).addClass("MasterCellCollapse").appendTo(trTemplate);
                }

                var fieldsOuterDiv = "<td class=\"EditCell\" colspan=" + (context.get_GroupedColumns().length + context.get_VisibleColumns().length) + "><form action='${RequestMapper}' id='" + this.get_gridId() + "EditForm' method=\"post\"><table cellspacing=\"0.25px\" class=\"Table\"><colgroup>";
                $.each(context.get_VisibleColumns(), function () {
                    fieldsOuterDiv += "<col />";
                });
                fieldsOuterDiv += "</colgroup><tbody></tbody>";
                $(trTemplate).append(fieldsOuterDiv);
                $(TBODY).append(trTemplate);
                var trEditTemplate = $("<tr></tr>");
                $.each(context.get_VisibleColumns(), function (index, val) {
                    var tdCell = $("<td></td>");
                    $(tdCell).addClass("RowCell");
                    if (val.cellEditType == 1 && !val.TemplateColumn)
                        $(tdCell).html("{{if " + val.Member + " == false}}<input type='checkbox' id='" + val.Member + "' name='" + val.Member + "'></input> {{else}}<input type='checkbox' id='" + val.Member + "' name='" + val.Member + "' checked='checked'></input>{{/if}}");
                    else if (val.cellEditType == 6 && !val.TemplateColumn)
                        $(tdCell).html("<select id='" + val.Member + "' name='" + val.Member + "' class='${" + val.Member + "}'></select>");
                    else if (val.TemplateColumn)
                        $(tdCell).html("");
                    else {
                        if (val.type == 'DateTime') {
                            var formatString = val.FormatText == "" ? "{0:dd/MM/yyyy}" : val.FormatText;
                            $(tdCell).html("<input type='text' class='hasDateTime' id='" + val.Member + "' name='" + val.Member + "' ></input>");
                            $($(tdCell).find('input:first')[0]).after("<div class='jsondatevalue'>{{= $item.format(\"" + formatString + "\", " + val.Member + ",\"" + val.Member + "\")}}</div>");
                        }
                        else
                            $(tdCell).html("<input type='text' id='" + val.Member + "' value='${" + val.Member + "}' name='" + val.Member + "' ></input>");
                        if (!val.AllowEditing)
                            $(tdCell.find('input:first')[0]).attr('disabled', 'disabled');
                    }
                    $(trEditTemplate).append(tdCell);
                });
                var EditCellTbody = $(TBODY).find('.EditCell').find('tbody')[0];
                $(EditCellTbody).append(trEditTemplate);
            }
            else if (this.get_grid()._editMode == "InlineForm") {
                $("#" + context.get_element().id + "_EditingJSONTemplate").remove();
                var DivElement = $("<div></div>");
                var Table = $("<table></table>");
                var TBODY = $("<tbody></tbody>");
                $(TBODY).appendTo(Table);
                var trTemplate = $("<tr></tr>");
                $(DivElement).attr('id', context.get_element().id + "_EditingJSONTemplate").css('display', 'none').appendTo('body').append(Table);
                var td = $("<td></td>");
                $(td).addClass('RowHeader');
                $(td).html("<div>&nbsp;</div>");
                $(trTemplate).append(td);
                var fieldsOuterDiv = "<td class=\"EditInlineForm EditCell\" colspan=" + (context.get_VisibleColumns().length + context.get_GroupedColumns().length) + "><form action='${RequestMapper}' class=\"EditForm\" id='" + this.get_gridId() + "EditForm' method=\"post\"><fieldset><legend>${LegendValue}</legend></fieldset></form></td>";
                $(trTemplate).append(fieldsOuterDiv);
                $(TBODY).append(trTemplate);
                var fieldset = $("#" + this.get_gridId() + "_EditingJSONTemplate .EditCell").find('fieldset');
                this._renderColumns(fieldset);
            }
            else if (this.get_grid()._editMode == "Dialog" || this.get_grid()._editMode == "ExternalForm") {
                var DivElement = $("<div></div>");
                $(DivElement).attr('id', context.get_element().id + "_EditingJSONTemplate").css('display', 'none').appendTo('body').append(Table);
                var fieldsOuterDiv = "<form action='${RequestMapper}' class=\"EditForm\" id='" + this.get_gridId() + "EditForm' method=\"post\"><fieldset></fieldset></form>";
                $(DivElement).append(fieldsOuterDiv);
                var fieldset = $("#" + this.get_gridId() + "_EditingJSONTemplate form").find('fieldset');
                this._renderColumns(fieldset);
            }
            else if (this.get_grid()._editMode == "InlineTemplateForm" || this.get_grid()._editMode == "DialogTemplate") {
                $("#" + this.get_gridId() + "_EditingJSONTemplate").appendTo('body');
            }
        }
    },
    add_initialFilterChoiceTemplate: function () {
        if (this.get_grid().get_AllowFiltering()) {
            var context = this.get_grid();
            $("#" + context.get_element().id + "_FilterChoiceJSONTemplate").remove();
            if (context.get_FilterDropDownType() == 1) {
                var sfchoicetemplate = "<div id='" + context.get_element().id + "_FilterChoiceJSONTemplate' class='sf-choiceList'></div>";
                $("body").append(sfchoicetemplate);
                var fieldsOuterDiv = "<div><label class='fields'>{{if (IsChecked == true) }}<input type='checkbox' value=\"${ Value }\" checked='checked'>${Value}</input>{{else}}<input type='checkbox' value=\"${ Value }\">${Value}</input>{{/if}}</label></div>"
                $("#" + context.get_element().id + "_FilterChoiceJSONTemplate").css('display', 'none').append(fieldsOuterDiv);
            } else {
                var parentDivElement = $("<div></div>");
                var select = $("<select></select>");
                $(parentDivElement).attr('id', context.get_element().id + "_FilterChoiceJSONTemplate");
                $(select).css('display', 'none').append("<option value=\"${Value}\">${Value}</option>").appendTo(parentDivElement);
                $("body").append(parentDivElement);
            }
        }
    },
    _renderColumns: function (fieldset) {
        var context = this.get_grid();
        $.each(context.get_VisibleColumns(), function (index, val) {
            if (!val.TemplateColumn) {
                var tdCell = $("<div></div>");
                $(tdCell).addClass("RecordCaption").append("<label for='" + val.Member + "'>" + val.Member + "</label>");
                var inputElement = "";
                if (val.cellEditType == 1)
                    inputElement = "{{if " + val.Member + " == false}}<input type='checkbox' id='" + val.Member + "' name='" + val.Member + "'></input> {{else}}<input type='checkbox' id='" + val.Member + "' name='" + val.Member + "' checked='checked'></input>{{/if}}";
                else if (val.cellEditType == 6)
                    inputElement = "<select id='" + val.Member + "' name='" + val.Member + "' class='${" + val.Member + "}'></select>";
                else {
                    if (val.type == 'DateTime') {
                        var formatString = val.FormatText == "" ? "{0:dd/MM/yyyy}" : val.FormatText;
                        inputElement = $("<input type='text' class='hasDateTime' id='" + val.Member + "' name='" + val.Member + "' ></input>");
                    }
                    else
                        inputElement = $("<input type='text' id='" + val.Member + "' value='${" + val.Member + "}' name='" + val.Member + "' ></input>");
                    if (!val.AllowEditing)
                        $(inputElement).attr('disabled', 'disabled');
                }
                var parentDiv = $("<div></div>");
                $(parentDiv).append(tdCell).append(inputElement).appendTo(fieldset);
                if (val.type == 'DateTime')
                    $(inputElement).after("<div class='jsondatevalue'>{{= $item.format(\"" + formatString + "\", " + val.Member + ",\"" + val.Member + "\")}}</div>");
            }
        });
        $("<p><input type=\"button\" value=\"Save\"></input><input type=\"button\" value=\"Cancel\"></input></p>").appendTo(fieldset);
    },
    _formatting: function (formatstring, str, Member) {
        formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
        var s = formatstring;
        if (formatstring.indexOf("{0:") != -1) {
            var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
            var formatVal = toformat.exec(formatstring);
            if (formatVal != null && str != null && str.format != null) {
                str = str.localeFormat(formatVal[2]);
            }
            else {
                return "";
            }
            return str;
        }
        else {
            $.each(this.data, function (dataIndex, dataValue) {
                s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
            });
            return s;
        }

    },
    _RenderColumnTemplate: function (columnName) {

        var template = $($("#" + "Grid1_" + columnName + "_Template").tmpl(this.data));
        return $(template[0]).html();
    },
    _renderGroupedRecords: function (loopInt, record, contentgrid) {
        var context = this.get_grid();
        var proxy = this;
        var trGroupCaption = $("<tr></tr>");
        var tdGroupRowheader = $("<td class=\"RowHeader\"></td>");
        $(tdGroupRowheader).html("<div>&nbsp;</div>").appendTo(trGroupCaption);
        for (loopCnt = 0; loopCnt < proxy._groupingColumnIndex; loopCnt++) {
            var tdIndentCell = $("<td></td>");
            $(tdIndentCell).addClass("IndentCell").appendTo(trGroupCaption);
        }
        var tdRecordExpandCollapse = $("<td></td>");
        $(tdRecordExpandCollapse).addClass("RecordPlusExpand").html("<div>&nbsp;</div>").appendTo(trGroupCaption);
        var tdGroupCaption = $("<td></td>");
        $(tdGroupCaption).addClass("GroupCaption").attr('colspan', (context.get_GroupedColumns().length - 1 - proxy._groupingColumnIndex) + context.get_VisibleColumnName().length).html(context.get_GroupedColumns()[proxy._groupingColumnIndex] + ": " + record.Key + " - " + record.Count + " Items").appendTo(trGroupCaption);
        $(trGroupCaption).appendTo(contentgrid);
        var sender = { nodes: trGroupCaption, data: record };
        proxy._EventHandler(sender, context);
        if (record.SubGroups == null) {
            $("#" + context.get_element().id + "_JSONTemplate").removeData("tmpl");
            $.each(record.Items, function (itemIndex, itemValue) {
                Array.add(proxy._currentJsonData, itemValue);
            });
            $(contentgrid).append("#" + context.get_element().id + "_JSONTemplate", record.Items, { rendered: proxy._EventHandler, format: proxy._formatting, ColumnTemplate: proxy._RenderColumnTemplate });
        }
        else {
            proxy._groupingColumnIndex += 1;
            $.each(record.SubGroups, function (loopCount, SubGroup) {
                proxy._renderGroupedRecords(loopInt + 1, SubGroup, contentgrid);
            });
            proxy._groupingColumnIndex -= 1;
        }
    },
    _EditAction: function (primaryKeyValues) {
        this.get_grid().SaveCancelInternalAction();
        var proxy = this;
        var en = $.Enumerable.From(this._currentJsonData).ToArray();
        $.each(this.get_grid()._MvcTable.get_primaryKeys(), function (index, value) {
            en = $.Enumerable.From(en).Where(function (p) {
                return eval('p.' + value + ' == primaryKeyValues[index]');
            }).ToArray();
        });
        var cloneArray = null;
        cloneArray = $.extend(true, {}, en);
        var actionHandler = proxy.get_grid().get_events().getHandler("OnRecordEdit");
        var eventArgs = new Syncfusion.Mvc.Grid.ActionEventArgs(cloneArray[0], "OnRecordEdit", "");
        if (actionHandler) {
            actionHandler(proxy.get_grid(), eventArgs);
            if (eventArgs.getCancel()) {
                return false;
            }
        }
        var context = this.get_grid();
        if (context._editMode == "Dialog" || context._editMode == "DialogTemplate" || context._editMode == "ExternalForm")
            this._MoveJSONEditTemplate(context);
        this.jsonSuccessAction(cloneArray[0], "BeginEdit", true);
    },
    _AddAction: function () {
        if (!(this.get_grid()._editMode == "AutoExcel" || this.get_grid()._editMode == "ManualExcel")) {
            this.get_grid().SaveCancelInternalAction();
            var proxy = this;
            var en = $.Enumerable.From(this._currentJsonData).ToArray();
            var cloneArray = null;
            cloneArray = $.extend(true, {}, en[0]);
            $.each(cloneArray, function (index, value) {
                eval("cloneArray." + index + "= ''");
            });

            var actionHandler = proxy.get_grid().get_events().getHandler("OnRecordAddNew");
            var eventArgs = new Syncfusion.Mvc.Grid.ActionEventArgs(cloneArray, "OnRecordAddNew", "");
            if (actionHandler) {
                actionHandler(proxy.get_grid(), eventArgs);
                if (eventArgs.getCancel()) {
                    return false;
                }
            }
        }
        var context = this.get_grid();
        if (context._editMode == "Dialog" || context._editMode == "DialogTemplate" || context._editMode == "ExternalForm")
            this._MoveJSONEditTemplate(context);
        this.jsonSuccessAction(cloneArray, "AddNew", true);

    },
    //append the json edit template after dialog edit template
    _MoveJSONEditTemplate: function (context) {
        var jsonTemplate = $("#" + context.get_element().id + "_EditingJSONTemplate");
        $('body').append(jsonTemplate);
    },
    _settingJSONData: function (requestType, JSONdata, Temprecords) {
        if (requestType == "Cancel" || requestType == "Refresh" || requestType == "Save" || requestType == "grouping" || requestType == "sorting" || requestType == "Filtering")
            this._stringDataandOption = JSONdata;
        if (requestType == "Refresh" || requestType == "Save")
            this._jsonDataAndOption = Temprecords;
    },
    bindDataToRows: function (data, rowIndexArray) {
        var proxy = this;
        var Temprecords = null;
        try {
            Temprecords = Sys.Serialization.JavaScriptSerializer.deserialize(data);
        }
        catch (E) {
            alert(E);
            return false;
        }
        $.each(rowIndexArray, function (index, val) {
            var record = $.Enumerable.From(Temprecords).Skip(index).Take(1).ToArray();
            if (record[0] != null)
                proxy.bindDataToRow(record[0], val, true);
        });
    },
    bindDataToRow: function (data, rowIndex, isDeserializedObj) {
        if (isDeserializedObj == null || !isDeserializedObj) {
            try {
                Temprecords = Sys.Serialization.JavaScriptSerializer.deserialize(data);
            }
            catch (E) {
                alert(E);
                return false;
            }
        } else {
            Temprecords = data;
        }
        if (Temprecords.length == undefined) {
            var tbody = $($(this.get_grid().get_element()).find(".GridContent table:first")[0]).find("tbody:first")[0];
            var TR = $(tbody).children('tr:eq(' + rowIndex + ')')[0];
            $("#" + this.get_gridId() + "_JSONTemplate").removeData("tmpl");
            if (TR != null) {
                $(TR).html('').append("#" + this.get_gridId() + "_JSONTemplate tr:first", Temprecords, { rendered: this._EventHandler, format: this._formatting });

            }
        }
    },
    bindTo: function (data, requestType) {
        var Temprecords = null;
        try {
            Temprecords = Sys.Serialization.JavaScriptSerializer.deserialize(data);
        }
        catch (E) {
            alert(E);
            return false;
        }
        if (Temprecords.length == undefined) {
            $.each(Temprecords, function (i, val) {
                records = val;
            });
        }
        else {
            records = Temprecords;
        }

        if (this.get_grid().get_Pager() != null) {
            records = $.Enumerable.From(records).Take(this.get_grid().get_Pager().get_PageSize()).ToArray();
        }

        if (requestType == null)
            requestType = "Refresh";
        this._settingJSONData(requestType, data, Temprecords);
        this.jsonSuccessAction(records, requestType, true);
    },
    clientSideRefresh: function () {
        this.jsonSuccessAction(this._currentJsonData, "Refresh", true);
    },

    //function to add a row when edit mode is set to AutoExcel or ManualExcel
    _bulkEditAddRow: function (context) {
        //setting the default value for newly added record
        if (context._edit._defaultDataItem == null) {
            context._edit._defaultDataItem = jQuery.extend(true, {}, context._edit._data[0]);
            //updating the default values for newly added records
            $.each(context.get_VisibleColumns(), function (indx, col) {
                switch (col.type) {
                    case "Decimal":
                        context._edit._defaultDataItem[col.Member] = 0.00;
                        break;
                    case "Int32":
                        context._edit._defaultDataItem[col.Member] = 0;
                        break;
                    case "String":
                        context._edit._defaultDataItem[col.Member] = "";
                        break;
                    case "Boolean":
                        context._edit._defaultDataItem[col.Member] = false;
                        break;
                }
            });
        }
        var onAddrecordHandler = context.get_events().getHandler("OnRecordAddNew");
        var eventArgs = new Syncfusion.Mvc.Grid.BulkEditEventArgs(null, null, null, context._edit._defaultDataItem, null);
        if (onAddrecordHandler)
            onAddrecordHandler(this, eventArgs);
        var tr = document.createElement("tr");
        var editTD, editTDType, editColName;
        var tbody = $("#" + context.get_element().id + "_Table").find('tbody')[0];
        $(tr).html("<td class='SelectedRowHeaderCell'><div class='HeaderIcon'>&nbsp;</div></td>");
        $(tr).addClass("InsertedRow");
        for (var i = 0; i < context._groupedColumns.length; i++) {
            var td = document.createElement("td");
            $(td).addClass("RecordPlusExpand");
            $(tr).append(td);
        }
        context._edit._blkEdtRequestType = "AddNew";
        context._edit._isEdit = true;
        if (!context._edit.updateTlbr)
            context._edit._updateToolbar(context);
        var proxy = this;
        $.each(context.get_VisibleColumns(), function (indx, col) {
            var td = document.createElement("td");
            $(td).addClass("RowCell");
            $(tr).append(td);
            if (indx == 0) {
                editTD = td;
                editTDType = col.cellEditType;
                editColName = col.Member;
                context._edit._formatString = col.FormatText;
                context._edit.colObj = col;
                context._edit.currentCellValue = context._edit._defaultDataItem[col.Member];
                $(td).addClass("CurrentCell");
                Array.add(context._edit._insertedRowsCollection, $(editTD).parent()[0]);
            }
            else {
                if (col.TemplateColumn) {
                    var div = document.createElement('div');
                    $(div).append("#" + context.get_element().id + "_" + col.Member + "_Template", context._edit._defaultDataItem);
                    $(td).html(div.children[0].innerHTML).addClass("updatedCell");
                }
                else {
                    if (col.type == "Boolean") {
                        $(td).addClass("BoolRowCell");
                        var value = context._edit._defaultDataItem[col.Member];
                        if (value)
                            $(td).html("<input type='checkbox' name='" + col.Member + "' disabled='disabled' checked='checked'/>");
                        else
                            $(td).html("<input type='checkbox' name='" + col.Member + "' disabled='disabled'/>");
                    }
                    else {
                        var value;
                        if (col.FormatText != "" || col.type == "DateTime") {
                            if (col.FormatText == "")
                                col.FormatText = "{0:dd/MM/yyyy}";
                            value = proxy._formatting(col.FormatText, context._edit._defaultDataItem[col.Member], col.Member);
                        }
                        else
                            value = context._edit._defaultDataItem[col.Member];
                        $(td).html(value.toString());
                    }
                    $(td).addClass("updatedCell");
                }
            }
        });
        //disable the save button in toolbar
        context.gridtoolbar.Disable_ToolbarItembyID(context.get_element().id + "Save");
        //removing the existing row selection
        $($("#" + context.get_element().id + "_Table tr td.SelectionBackground")).removeClass("SelectionBackground").removeClass("CurrentCell");
        $($("#" + context.get_element().id + "_Table tr td.SelectedRowHeaderCell div")).removeClass("HeaderIcon");
        $($("#" + context.get_element().id + "_Table tr td.SelectedRowHeaderCell")).removeClass("SelectedRowHeaderCell").addClass("RowHeader");

        //updating the selection manager
        context._selectionManager.selectedRowsCollection = new Array();
        Array.add(context._selectionManager.selectedRowsCollection, 0);
        context._selectionManager._currentCell[0] = 0;
        context._selectionManager._currentCell[1] = 1;
        $(tbody).prepend(tr);
        $(tr).find('td').not('.SelectedRowHeaderCell').addClass("SelectionBackground");
        Array.add(context._edit._addedRecords, jQuery.extend(true, {}, context._edit._defaultDataItem));
        context._edit._renderBulkEditObject(editTDType, editTD, editColName);
        context._edit._setFormContext();
        context._edit._callTimeOut(context);
    },
    jsonSuccessAction: function (JSONdata, requestType, isDeserializedObj) {
        var context = this.get_grid();
        var lastColWidth = $(context._scrollerHdrEl).find('table:first colgroup col:last').css('width');
        var proxy = this;
        var records = null;
        var Temprecords = null;
        isDeserializedObj == isDeserializedObj || false;
        if (!isDeserializedObj) {
            try {
                Temprecords = Sys.Serialization.JavaScriptSerializer.deserialize(JSONdata);
                if (context.get_WebService() != null)
                    records = Temprecords.d.Data;
                else
                    records = Temprecords.JSONdata;
                this._settingJSONData(requestType, JSONdata, Temprecords);
            }
            catch (E) {
                alert(E);
                return false;
            }
        }
        else {
            records = JSONdata;
        }
        context.removeVirtualScroller();
        if ((context._editMode == "AutoExcel" || context._editMode == "ManualExcel") && requestType == "AddNew") {
            this._bulkEditAddRow(context);
        }
        else {
            if (requestType == "FilterChoiceRequest") {
                var dataTemplate = $("#" + context.get_element().id + "_FilterChoiceJSONTemplate").tmpl(records);
                var sfChoiceList = $("<div class='sf-choiceList'></div>");
                $(sfChoiceList).append(dataTemplate);
                context.FilteringMgr._FilterAction(sfChoiceList);
                if (context._waiting != null)
                    context._waiting.HidePopUp();
            }
            else if (requestType == "BeginEdit" || requestType == "AddNew") {
                if (requestType == "BeginEdit") {
                    records["RequestMapper"] = context._gridSaveMapper;
                    records["LegendValue"] = context.get_LocalizedStrings().editrecordcaption + " " + eval("records." + proxy.get_grid()._MvcTable.get_primaryKeys()[0]);
                }
                else {
                    records["LegendValue"] = context.get_LocalizedStrings().addnewrecord;
                    records["RequestMapper"] = context._gridAddNewMapper;
                }

                if (context._editMode == "Normal") {
                    $("#" + context.get_element().id + "_EditingJSONTemplate").find('td[class*=IndentCell]').remove();
                    $.each(context.get_GroupedColumns(), function (index, val) {
                        var tdIndent = $("<td>&nbsp;</td>");
                        $(tdIndent).addClass("IndentCell").insertBefore($("#" + context.get_element().id + "_EditingJSONTemplate").find('td[class*=RowCell]')[0]);
                    });
                    $($("#" + context.get_element().id + "_EditingJSONTemplate").find('td[class*=EditCell]')[0]).attr('colspan', context.get_GroupedColumns().length + context.get_VisibleColumns().length);
                }

                $("#" + context.get_element().id + "_EditingJSONTemplate").removeData("tmpl");

                var div = $("<div></div>");
                $(div).append("#" + proxy.get_gridId() + "_EditingJSONTemplate", records, { format: proxy._formatting });
                context._editingAction(requestType, div);
                $.each($("#" + proxy.get_gridId() + "EditForm").find('input.hasDateTime'), function (loopCnt, Element) {
                    var sibling = $(Element).next('div')[0];
                    $(Element).val($(sibling).html());
                    $(Element).parent().find('.jsondatevalue').remove();
                });
                $("#" + proxy.get_gridId() + "EditForm").find('select').removeAttr('selected');
                $.each($("#" + proxy.get_gridId() + "EditForm").find('select'), function (loopCnt, Element) {
                    var options = $(Element).children('option[value=' + $(Element).attr('class') + ']');
                    if (options.length > 0) {
                        $(options[0]).attr('selected', 'selected');
                        $(Element).removeClass();
                    }
                });

                if (context._editMode == "InlineTemplateForm" || context._editMode == "DialogTemplate") {
                    $.each(records, function (recordKey, recordValue) {
                        $("#" + proxy.get_gridId() + "EditForm").find("#" + recordKey).val(recordValue);
                    });
                } if (requestType == "BeginEdit") {
                    $.each(this.get_grid()._MvcTable.get_primaryKeys(), function (index, value) {
                        $("#" + proxy.get_gridId() + "EditForm").find("#" + value).attr("disabled", "disabled");
                    });
                }
            }
            else {
                this._currentJsonData = records;
                var tbody = $($(context.get_element()).find(".GridContent table:first")[0]).find("tbody:first")[0];
                if (requestType == "Save" || requestType == "Cancel") {
                    context.SaveCancelInternalAction();
                }
                if (context._editMode == "AutoExcel" && requestType == "Save")
                    window.clearTimeout(context._edit._timer);
                if (!(this.get_grid().get_AllowVirtualScrolling() && (requestType == "Save" || requestType == "Cancel" || requestType == "paging" || requestType == "Delete"))) {
                    $(tbody).empty();
                }
                if (context._editMode == "AutoExcel" || context._editMode == "ManualExcel") {
                    context.gridtoolbar.Disable_ToolbarItembyID(context.get_element().id + "Edit_Record");
                    context.SaveCancelInternalAction();
                    context._edit.updateTlbr = false;
                    context._edit._updatedRecords = new Array();
                    context._edit._addedRecords = new Array();
                    context._edit._deletedRecords = new Array();
                    context._edit._insertedRowsCollection = new Array();
                }
                var GridheaderCol = $(context.get_element()).find('.GridHeader table:first colgroup')[0];
                var GridcontentCol = $(context.get_element()).find('.GridContent table:first colgroup')[0];
                var masterCell = 0;
                if (proxy.get_grid().get_childGrid() != null && proxy.get_grid().get_childGrid() != "")
                    masterCell = 1;
                $(GridcontentCol).children('col:gt(0):lt(' + ($(GridcontentCol).children('col').length - 1 - masterCell - context.get_VisibleColumns().length) + ')').remove();
                $(GridheaderCol).children('col:gt(0):lt(' + ($(GridheaderCol).children('col').length - 2 - masterCell - context.get_VisibleColumns().length) + ')').remove();
                var GridheaderTH = $(context.get_element()).find('.GridHeader table:first tr')[context._headerRowIndex];
                $(GridheaderTH).find('.GroupTopLeftCell').remove();
                $("#" + context.get_element().id + "_JSONTemplate").find('td[class*=IndentCell]').remove();
                $.each(context.get_GroupedColumns(), function (index, val) {
                    var tdIndent = $("<td>&nbsp;</td>");
                    $(tdIndent).addClass("IndentCell").insertAfter($("#" + context.get_element().id + "_JSONTemplate").find('td[class*=RowHeader]')[0]);
                    $("<th class=\"GroupTopLeftCell\"><div class=\"HeaderCellDiv\">&nbsp;</div></th>").insertAfter($(GridheaderTH).children('th')[0]);
                    $("<col style='width:20px;'>").insertAfter($(GridheaderCol).children('col')[0]);
                    $("<col style='width:20px;'>").insertAfter($(GridcontentCol).children('col')[0]);
                });

                if (requestType == "Refresh") {
                    var listofDropdown = $("#" + proxy.get_gridId() + "_EditingJSONTemplate").find('select');

                    $("#" + context.get_element().id + "_EditingOptionsJSONTemplate").removeData("tmpl");
                    $.each(listofDropdown, function (indexofDropDown, DropDown) {
                        var value = eval("proxy._jsonDataAndOption." + DropDown.id + "_Options");
                        $(DropDown).html($($("#" + context.get_element().id + "_EditingOptionsJSONTemplate").tmpl(value)).find('option'));
                    });
                }
                if (context.get_GroupedColumns().length > 0) {
                    proxy._currentJsonData = new Array();
                    $.each(records, function (index, value) {
                        proxy._renderGroupedRecords(index, value, tbody);
                    });
                }
                else {
                    $("#" + context.get_element().id + "_JSONTemplate").removeData("tmpl");
                    if (records.length > 0)
                        $(tbody).append("#" + context.get_element().id + "_JSONTemplate", records, { rendered: this._EventHandler, format: proxy._formatting, ColumnTemplate: proxy._RenderColumnTemplate });
                    else {
                        var tr = document.createElement('tr');
                        var td = document.createElement('td');
                        $(td).addClass("EmptyCell").attr("colspan", "7").html(context.get_LocalizedStrings().emptytext);
                        $(tr).append(td);
                        $(tbody).append(tr);
                    }
                }
                if (requestType == "RowsDropping") {
                    // Dropped Event
                    context._DroppedEvent();
                }
                if (this.get_grid().get_AllowVirtualScrolling()) {
                    if (requestType == "Save" || requestType == "Cancel" || requestType == "paging" || requestType == "Delete") {
                        context._replacingContent(tbody, true);
                    } else {
                        context.refreshVirtualContent();
                    }
                }
                if (Temprecords != null && Temprecords.Summary != null) {
                    var footer = $(context.get_element()).find(".GridFooter")[0];
                    var contentEl = $(context.get_element()).find(".GridContent")[0];
                    $(footer).find('.GridSummary').remove();
                    var gridSummary = $("<table class='Table GridSummary' id='" + proxy.get_gridId() + "_SummaryTable'></table>");
                    $(gridSummary).html($($(contentEl).find('table:first').find('colgroup')[0]).clone()).append('<tbody></tbody>');
                    $(footer).prepend(gridSummary);
                    var templateClone = $("#" + proxy.get_gridId() + "_JSONTemplate").clone();
                    $("#" + proxy.get_gridId() + "_SummaryTemplate").remove();
                    $(templateClone).attr('id', proxy.get_gridId() + "_SummaryTemplate").appendTo('body').find('td').removeClass().addClass("Summary");
                    $.each($(templateClone).find('td'), function (tdCellIndex, td) {
                        if (tdCellIndex == context._groupedColumns.length + 1)
                            $(td).html("${ GridSummaryTitle}");
                        else if (tdCellIndex != 0 && td.cellIndex > context._groupedColumns.length)
                            $(td).html("${ " + proxy.get_grid().get_VisibleColumns()[tdCellIndex - 1 - context._groupedColumns.length].Name + "}");

                    });
                    $("#" + proxy.get_gridId() + "_SummaryTemplate").removeData("tmpl");
                    $(gridSummary).find('tbody:first').append("#" + proxy.get_gridId() + "_SummaryTemplate", Temprecords.Summary, { rendered: this._EventHandler });
                }
                if (requestType == "grouping") {
                    var columnIndex = null;
                    if (context._currentUnGroupedColumn != null) {
                        columnIndex = context._MvcTable.get_columnIndexByMember(context._currentUnGroupedColumn) + 1 + context.get_GroupedColumns().length;
                        $($(context.get_element()).find('.GridHeader table:first th')[columnIndex]).find('div:first').removeClass('Ascending').removeClass('Descending');
                        context._currentUnGroupedColumn = null;
                    }
                    context._groupingAction();
                }
            }
            if (context._editMode == "AutoExcel" || context._editMode == "ManualExcel")
                context._edit._data = this._currentJsonData;
            context._reLoadEssentialsAtGridReferesh(context, requestType);
            $(context._scrollerHdrEl).find('table:first colgroup col:last').css('width', lastColWidth);
        }
    },
    _EventHandler: function (sender, grid) {
        if (sender.nodes.length > 0) {
            if (grid == null) {
                var contentTable = $(sender.nodes[0]).parents('table:first')[0];
                if (contentTable == null)
                    return;
                var gridId = contentTable.id.replace("_Table", "");
                if (gridId == "")
                    return;
                grid = $find(gridId);
                if (grid == null)
                    return;
            }
            var arrayIndex = $.inArray(sender.data, grid.jsonModeMgr._currentJsonData);
            if (arrayIndex >= 0) $(sender.nodes[0]).addClass((arrayIndex % 2) ? "Alt_Row" : "");
            var querCellInfoHandler = grid.get_events().getHandler("QueryCellInfo");
            if (querCellInfoHandler) {
                $.each($(sender.nodes[0]).children('td'), function (cellIndex, td) {
                    var col = null;
                    if (td.cellIndex == 0)
                        col = { ColumnType: "RowHeader" };
                    else {
                        if ($(td).hasClass('IndentCell') || $(td).hasClass('GroupCaption') || td.className.indexOf('RecordPlus') != -1 || $(td).hasClass('Summary'))
                            col = { ColumnType: td.className };
                        else
                            col = grid.get_VisibleColumns()[td.cellIndex - 1 - grid._groupedColumns.length];
                    }
                    var args = { Element: td, Data: sender.data, Column: col, Text: $(td).html() };
                    querCellInfoHandler(grid, args);
                });
            }
            var rowDataBoundHandler = grid.get_events().getHandler("RowDataBound");
            var isAlt = (arrayIndex % 2) ? true : false;
            var Expanded = false;
            var args = { Element: sender.nodes[0], Data: sender.data, IsAlternate: isAlt, Expanded: Expanded };
            if (rowDataBoundHandler) {
                rowDataBoundHandler(grid, args);
            }
            if (args.Expanded) {
                $(args.Element).children('td[class*=MasterCellCollapse]').removeClass('MasterCellCollapse').addClass('MasterCellExpand');
            }
        }
    },
    StringifyObject: function (obj) {
        var result = [];
        for (var key in obj) {
            var value = obj[key];
            if (typeof (value) == "string")
                result.push('"' + key + '":"' + value.replace(/"/g, '\\"') + '"');
            else
                result.push('"' + key + '":' + value);
        }
        return result;
    },
    Stringify: function (obj1, bindingName1, obj2, bindingName2) {
        var result1 = [];
        var result2 = [];
        result1 = this.StringifyObject(obj1);
        if (obj2 != null && obj2 != undefined) {
            result2 = this.StringifyObject(obj2);
            return '{"' + bindingName1 + '":{' + result1.join(',') + '},"' + bindingName2 + '":{' + result2.join(',') + '}}';
        }
        else {
            return '{"' + bindingName1 + '":{' + result1.join(',') + '}}';
        }
    },

    _sendJsonActionRequest: function (reqargs, requestType, mappingmethod) {
        var context = this.get_grid();
        var proxy = this;
        var actionHandler = context.get_events().getHandler("OnActionBegin");
        var eventArgs = new Syncfusion.Mvc.Grid.ActionEventArgs(reqargs, requestType, mappingmethod);
        if (actionHandler) {
            actionHandler(context, eventArgs);
            if (eventArgs.getCancel()) {
                context._RevertAction(requestType);
                return false;
            }
        }
        if (requestType != "Save" && requestType != "FilterChoiceRequest" && requestType != "grouping" && $("#" + context.get_element().id + " td").hasClass("updatedCell")) {
            if (!confirm(context.get_LocalizedStrings().BulkEditAlert)) {
                context._RevertAction(requestType);
                return;
            }
        }
        if (context._waiting == null)
            context._waiting = $find(context.get_element().id + "waiting");
        if (context._waiting != null) context._waiting.ShowPopUp();
        if (context._selectionManager != null)
            context._selectionManager._cleanUp();
        var Data;
        var _contentType;
        if (context.get_WebService() != null) {
            if (requestType == "Delete")
                Data = this.Stringify(reqargs, "webParams", context._primaryKeyValue, "KeyValue");
            else if (requestType == "Save")
                Data = this.Stringify(reqargs, "webParams", context._gridEditingObj, "datasourceObj");
            else {
                mappingmethod = context.get_WebService();
                Data = this.Stringify(reqargs, "webParams");
            }
            _contentType = "application/json; charset=utf-8";
        }
        else {
            Data = reqargs;
            _contentType = "application/x-www-form-urlencoded";
        }
        if ((requestType == "Save" || requestType == "Cancel") && (context._editMode == "Dialog" || context._editMode == "DialogTemplate" || context._editMode == "ExternalForm")) {
            $("#" + context.get_element().id + "_EditDialog").dialog("close");
            $("#" + context.get_element().id + "_ExternalForm").remove();
        }
        var callback = $.ajax({
            type: context.get_HttpRequestType(),
            url: mappingmethod,
            data: Data,
            contentType: _contentType,
            dataType: 'JSON',
            success: function (JSONdata) {
                if (requestType == "Filtering" || requestType == "Delete" || requestType == "Save" || requestType == "RowsDropping" || requestType == "Refresh") {
                    var json = Sys.Serialization.JavaScriptSerializer.deserialize(callback.getResponseHeader("ClientObject"));
                    context._CommonSuccessAction(json);
                }
                context.set_CurrentIndex(Data.StartIndex);
                proxy.jsonSuccessAction(JSONdata, requestType, false);
            },
            complete: function (XMLHttpRequest, textStatus) {
                var actionHandler = context.get_events().getHandler("OnActionComplete");
                var eventArgs = {
                    RequestType: requestType,
                    Status: textStatus
                };
                if (actionHandler) {
                    actionHandler(context, eventArgs);
                }
            },
            error: function (e, status) {
                if (context._waiting != null)
                    context._waiting.HidePopUp();
                var actionHandler = context.get_events().getHandler("OnActionFailure");

                var eventArgs = {
                    RequestType: requestType,
                    Status: status
                };
                if (actionHandler) {
                    actionHandler(context, eventArgs);
                }
                context._RevertAction(requestType);
            }
        });

    }

}
Syncfusion.Mvc.Grid.JSONMode.registerClass("Syncfusion.Mvc.Grid.JSONMode", Sys.Component);

